module Passety
  class Item
    def initialize(wrapper, uri = '')
      @wrapper = wrapper
      @uri = uri
    end

    def all(params = {})
      @wrapper.perform_request { |c| c.get(@uri, params) }
    end

    def find(id, params = {})
      @wrapper.perform_request { |c| c.get(url(id), params) }
    end

    def update(id, params)
      @wrapper.perform_request { |c| c.put(url(id), JSON.generate(params)) }
    end

    def create(params)
      @wrapper.perform_request { |c| c.post(@uri, JSON.generate(params)) }
    end

    def destroy(id)
      @wrapper.perform_request { |c| c.delete(url(id)) }
    end

    private
    def url(id)
      encode('/' + [ @uri, id ].join('/'))
    end

    def encode(val)
      URI.encode(val, /[^\-_.!~*'()a-zA-Z\d;\/?:@&=+$,]/)
    end
  end
end
