module Passety
  class Upload
    def initialize(wrapper)
      @wrapper = wrapper
    end

    def create(params)
      @wrapper.perform_request { |c| c.post('/uploads', &upload_file(params)) }
    end

    private
    def upload_file(params)
      file = params.delete(:file)
      proc do |req|
        req.url(url_with_params(params))
        req.body = file.tempfile.read
        req.headers['Content-Type'] = file.content_type
        req.headers['Content-Disposition'] = "attachment; filename=\"#{file.original_filename}\""
      end unless file.nil?
    end

    def url_with_params(params)
      uri = URI.parse('/uploads')
      uri.query = URI.encode_www_form(params)
      uri
    end
  end
end
